# -*- encoding: utf-8 -*-
import numpy as np
import numpy.linalg
from numpy.linalg import norm
import scipy
from scipy import random
import scipy.linalg as lalg


np.set_printoptions(linewidth=200, formatter={'float': '{: 0.3f}'.format})

n = 99 #99
d = 50*(1.-0.5**np.linspace(1.,5,n))
random.seed(4) # do NOT delete this line
Q, _ = np.linalg.qr(random.rand(n, n))
A = np.dot(Q.transpose(), np.dot(np.diag(d), Q))

# (a)
ew = np.zeros(n) # Eigenwerte
ev = np.ones((n,n)) # Eigenvektoren

# TODO: berechnen Sie die richtigen ew und ev

print("Eigenvalues of A : ")
print(ew)
print(ev)

# (b.i)

def power_method(A, x, maxit = 10000, tol = 1e-8):
    r""" Power Method.
    INPUT: 
    A          :       Matrix
    x          :       Vector to start the iteration
    maxit      :       Maximal number of repetitions for the power method
    tol        :       Tolerance in Eigenvalue
    OUTPUT: 
    eigenvalue :       Largest eigenvalue of A
    x          :       Eigenvector
    k          :       How many iteartions were needed
    """
    # TODO: Ersetzen Sie die volgenden 3 Zeilen mit der richtigen Implementierung
    lmax = 0
    x = 0
    k = 0

    return lmax, x, k

print('--------------------------\n (b.i)')
# TODO: Implementierung
x = 0

rho, x, k = power_method(A,x)
print('Power metod stopped after ',k, 'iterations')
print("The biggest eigenvalue of A is : " + str(rho))

# (b.ii)
print('--------------------------\n (b.ii)')

# TODO: Implementierung

lmin = 0
print('Power metod stopped after ',k, 'iterations')
print("The smallest eigenvalue of A via shifted PM is : " + str(lmin))

# (b.iii)
def inverse_power_method(A, x, maxit = 10000, tol = 1e-8):
    r""" Inverse Power Method, with LU-P decomposition.
    INPUT: 
    A          :       Matrix
    x          :       Vector to start yhe iteration
    maxit      :       Maximal number of repetitions for the power method
    tol        :       Tolerance in Eigenvector
    OUTPUT: 
    eigenvalue :       smallest eigenvalue of A
    x          :       Eigenvector
    k          :       How many iteartions were needed
    """
    # TODO: Ersetzen Sie die volgenden 3 Zeilen mit der richtigen Implementierung
    lmin = 0
    x = 0
    k = 0
	
    return lmin, x, k



print('--------------------------\n (b.iii)')
# TODO: Implementierung

rho, x, k = inverse_power_method(A,x)
print('Inverese Power method stopped after ',k, 'iterations')
print("The smallest eigenvalue of A is : " + str(rho))

# (b.iv)

def shifted_inverse_power_method(A, alpha, x, maxit = 10000, tol = 1e-8):
    r""" Inverse Power Method, with LU-P decomposition.
    INPUT: 
    A          :       Matrix
    alpha      :       Reference value
    x          :       Vector to start yhe iteration
    maxit      :       Maximal number of repetitions for the power method
    tol        :       Tolerance in Eigenvector
    OUTPUT: 
    eigenvalue :       smallest eigenvalue of A
    x          :       Eigenvector
    k          :       How many iteartions were needed
    """
    # TODO: Ersetzen Sie die volgenden 3 Zeilen mit der richtigen Implementierung
    lmin = 0
    x = 0
    k = 0

    return lmin, x, k

print('--------------------------\n (b.iv)')
# TODO: Implementierung

v = 0. 
rho, x, k = shifted_inverse_power_method(A,v,x)
print('Inverse Power metod stopped after ',k, 'iterations')
print("The closest eigenvalue of A to " + str(v) + " is : " + str(rho))
    
# (c) auf Papier

