from numpy import *
from matplotlib.pyplot import *
import sympy as sym




# (a)
print('--------------------------\n (a)')
# TODO: Ein Teil auf Papier




# Butcher-Tabelle der Kutta38-Regel
Kutta38 = array([[0  , 0   , 0  , 0  , 0  ],    
                 [1/3, 1/3 , 0  , 0  , 0  ],
                 [2/3, -1/3, 1  , 0  , 0  ],
                 [1  , 1   , -1 , 1  , 0  ],
                 [0  , 1/8 , 3/8, 3/8, 1/8]])

bs_B = sym.Matrix(Kutta38)


sn = bs_B.shape[0] - 1 # number of stages 
bs_A = bs_B[:-1,1:]
bs_c = bs_B[:-1,0] 
bs_b = bs_B[-1,1:]


# TODO: Ersetzen Sie die folgende Zeile mit der richtigen Implementierung

S_ = 1

print('Die Stabilitaetsfunktion ist:')
sym.pprint(sym.simplify(S_))

# (b)
print('--------------------------\n (b)')

# logistische Diffrentialgleichung
# TODO: Implementierung der rechten Seite

# Die exakte Loesung:
y_analytic = lambda t: exp(10*t)/(99.+exp(10*t))
ti = 0.0 # Startzeit
te = 1.0 # Endzeit
y0 = 0.01 # Startwert

tspan = [ti, te]
y_end_exact = y_analytic(te)

# verschiedene Anzahl Schritte
Ns = arange(10,1500,50)

err = []
hs = []

# TODO: Implementiere RK und simuliere um die Fehler fuer verschiedene Anzahl Schritte zu berechnen


hs = array(hs)
err = array(err)

# TODO: finde die Konvergenzordnung

conv = 0
print('Konvergenzordnung fuer f1 ist:', conv)

figure()
loglog(hs, err, 'x', label='RK38')
loglog(hs, hs**int(conv), label='$h^'+str(int(conv))+'$')
grid(True); xlabel("$h$"); ylabel("err")
legend(loc="best")
show()

# (c)
# Auf Papier


# (d)
# Auf Papier

