# -*- coding: utf-8 -*-
#from sympy import * 
import numpy as np
import matplotlib.pyplot as plt
from scipy.integrate import quad

nodes = np.array([ \
	-0.906179845939, -0.538469310106,  0.,  0.538469310106,  0.906179845939
	] )

weights = np.array ( [ \
	0.236926885056, 0.478628670499, 0.568888888889, 0.478628670499,  0.236926885056
		 ] )
# (a)
print('--------------------------\n (a)')

def Q(f,x,w):
	r""" Quadraturrule.
	INPUT:
		f 		: Function
		x		: nodes of the quadrature rule
		w       : weights of the quadrature rule
	OUTPUT:
		q 		: approximate value of the integral of f
	"""

	# TODO: Ersetzen Sie die folgende  Zeile mit der richtigen Implementierung
	q = 0
	
	return q


# TODO: Implementierung und Ausgabe


# (b)
# Auf Papier


# (c)
print('--------------------------\n (c)')
def composite_Q(f,a,b,N,xn,wn):
	r""" Approximate Quadrature rule.
	INPUT: 
		f 		: Function
		a 		: left point of integration
		b 		: right point of integration
		N 		: total number of sub intervals
		xn 		: nodes of the quadrature
		wn 		: weights of the quadrature
	"""
	I = 0.
	# TODO: Implementierung
	
	return I
def Plot_Convergence(res, err, lab):
	r""" Plot order of convergence
	INPUT : 
		res 		 	: Resolutions
		err 			: Errors
		lab 			: label of the plot
	"""
	plt.loglog(res,err,'o-',label=lab)
	plt.xlabel("Anzahl der Teilintervalle n")
	plt.ylabel("Fehler")

def f1(x):
	return  1.0 / (1.0 + 5.0*x**2)

def f2(x):
	return np.sqrt(x)



I1 =  np.arctan(np.sqrt(5))/np.sqrt(5)
I2 = 2./3.

NN = np.arange(2,20)
res1 = []
res2 = []
for N in NN:
	res1 += [ abs( I1 - composite_Q(f1, 0., 1., N, nodes, weights) )]
	res2 += [ abs( I2 - composite_Q(f2, 0., 1., N, nodes, weights) )]

# Finden Sie die Konvergenzordnung fuer f1

conv1 = 0 
print('Konvergenzordnung fuer f1 ist:', conv1)

# Finden Sie die Konvergenzordnung fuer f2

conv2 = 0 
print('Konvergenzordnung fuer f1 ist:', conv2)
	
Plot_Convergence(NN,res1,"$Q(f_1)$")
Plot_Convergence(NN,res2,"$Q(f_2)$")

plt.loglog(NN, 1e-3*(1.0*NN)**-conv2, "-k", label=r"$n^{"+str(-conv2)+"}$")
plt.loglog(NN, 1e-3*(1.0*NN)**-4, "-.k", label=r"$n^{-4}$")
plt.loglog(NN, 1.e-4*(1.0*NN)**-conv1, "--k", label=r"$n^{"+str(-conv1)+"}$")
	
plt.grid(True)
plt.legend(loc = "best")
plt.savefig("convergence.png")
plt.show()




